> ## Documentation Index
> Fetch the complete documentation index at: https://docs.shipstream.io/llms.txt
> Use this file to discover all available pages before exploring further.

# List all Locations

> Returns a list of `Location` objects specified by a warehouse `id` path parameter.



## OpenAPI

````yaml GET /v1/inventory/warehouses/{id}/locations
openapi: 3.0.3
info:
  title: ShipStream
  version: '1.0'
  license:
    name: Commercial (Copyright 2025 - All Rights Reserved)
    url: https://shipstream.io
  contact:
    name: ShipStream Support
    email: help@shipstream.io
  termsOfService: https://shipstream.io/legal/api-terms/
servers:
  - url: https://{base_url_domain}/api/global
    description: Direct API Url
    variables:
      base_url_domain:
        default: example.shipstream.app
        description: >-
          The fully qualified domain name for your ShipStream WMS instance. This
          is either a custom domain, or a subdomain of shipstream.app,

          and will be the same as the domain name for the page which you use to
          login to ShipStream WMS.
security:
  - ShipStream_bearerAuth: []
tags:
  - name: Warehouses
    x-displayName: Warehouses
  - name: Products
    x-displayName: Products
  - name: Locations
    x-displayName: Locations
  - name: Levels
    x-displayName: Levels
  - name: HoldReasons
    x-displayName: HoldReasons
  - name: Holds
    x-displayName: Holds
  - name: Deliveries
    description: Every thing about a Delivery Receiving
    x-displayName: Deliveries
  - name: Shipments
    x-displayName: Shipments
  - name: Orders
    x-displayName: Orders
  - name: Retailers
    x-displayName: Retailers
  - name: Users
    x-displayName: Users
  - name: User Roles
    x-displayName: User Roles
  - name: Merchants
    x-displayName: Merchants
  - name: Healthcheck
    x-displayName: Healthcheck
paths:
  /v1/inventory/warehouses/{id}/locations:
    get:
      tags:
        - Locations
      summary: List all Locations
      description: >-
        Returns a list of `Location` objects specified by a warehouse `id` path
        parameter.
      operationId: getLocations
      parameters:
        - name: id
          in: path
          schema:
            type: integer
            format: int32
          required: true
          description: The `id` of the referenced `Warehouse`.
        - $ref: '#/components/parameters/Inventory_API_v1_location-fields'
        - $ref: '#/components/parameters/Inventory_API_v1_fields-lot'
        - $ref: '#/components/parameters/Inventory_API_v1_fields-lot-lot_type'
        - $ref: '#/components/parameters/Inventory_API_v1_fields-lot-product'
        - $ref: '#/components/parameters/Inventory_API_v1_fields-product'
        - $ref: '#/components/parameters/Inventory_API_v1_fields-product-merchant'
        - $ref: '#/components/parameters/Inventory_API_v1_fields-rack'
        - $ref: '#/components/parameters/Inventory_API_v1_fields-rack-rack_type'
        - $ref: '#/components/parameters/Inventory_API_v1_fields-rack-warehouse'
        - $ref: '#/components/parameters/Inventory_API_v1_fields-location_type'
        - $ref: '#/components/parameters/Inventory_API_v1_location-filter'
        - name: sort
          in: query
          schema:
            type: string
          required: false
          description: >-
            The default sort order is **descending** by primary key
            (`sort=-id`).

            The following fields are available for sorting:
              - `id`
              - `label`
        - $ref: '#/components/parameters/Inventory_API_v1_count'
        - $ref: '#/components/parameters/Inventory_API_v1_cursor_end'
        - $ref: '#/components/parameters/Inventory_API_v1_cursor_start'
        - $ref: '#/components/parameters/Inventory_API_v1_limit'
      responses:
        '200':
          description: >-
            A dictionary with a `collection` property that contains a list of up
            to

            `limit` `Location` objects matching the query.
          content:
            application/json:
              schema:
                type: object
                properties:
                  collection:
                    type: array
                    description: A list of `Location` objects.
                    items:
                      $ref: '#/components/schemas/Inventory_API_v1_Location'
                  included:
                    $ref: '#/components/schemas/Inventory_API_v1_locations'
                  has_more:
                    $ref: '#/components/schemas/Inventory_API_v1_has_more'
                  next:
                    $ref: '#/components/schemas/Inventory_API_v1_next'
                  previous:
                    $ref: '#/components/schemas/Inventory_API_v1_previous'
                  meta:
                    $ref: '#/components/schemas/Inventory_API_v1_meta'
        '400':
          $ref: '#/components/responses/Inventory_API_v1_400-bad-request'
        '500':
          $ref: '#/components/responses/Inventory_API_v1_500-internal-server-error'
components:
  parameters:
    Inventory_API_v1_location-fields:
      name: fields
      in: query
      required: false
      description: >-
        Specify additional fields of the `Location` object to be included in the
        response.

        See the [selecting fields](/global-api/selecting-fields) page for more
        information.
      explode: false
      schema:
        $ref: '#/components/schemas/Inventory_API_v1_location-fields-enum'
    Inventory_API_v1_fields-lot:
      name: fields:lot
      in: query
      required: false
      description: >-
        Specify additional fields of the `Lot` object to be included in the
        response. See the [selecting fields](/global-api/selecting-fields) page
        for more information.
      explode: false
      schema:
        $ref: '#/components/schemas/Inventory_API_v1_lot-fields-enum'
    Inventory_API_v1_fields-lot-lot_type:
      name: fields:lot.lot_type
      in: query
      required: false
      description: >-
        Specify additional fields of the `LotType` object (via Lot) to be
        included in the response. See the [selecting
        fields](/global-api/selecting-fields) page for more information.
      explode: false
      schema:
        $ref: '#/components/schemas/Inventory_API_v1_lot_type-fields-enum'
    Inventory_API_v1_fields-lot-product:
      name: fields:lot.product
      in: query
      required: false
      description: >-
        Specify additional fields of the `Product` object (via Lot) to be
        included in the response. See the [selecting
        fields](/global-api/selecting-fields) page for more information.
      explode: false
      schema:
        $ref: '#/components/schemas/Inventory_API_v1_product-packaging-fields-enum'
    Inventory_API_v1_fields-product:
      name: fields:product
      in: query
      required: false
      description: >-
        Specify additional fields of the `Product` or `Packaging*` object to be
        included in the response. See the [selecting
        fields](/global-api/selecting-fields) page for more information.
      explode: false
      schema:
        $ref: '#/components/schemas/Inventory_API_v1_product-packaging-fields-enum'
    Inventory_API_v1_fields-product-merchant:
      name: fields:product.merchant
      in: query
      required: false
      description: >-
        Specify additional fields of the `Merchant` object to be included in the
        response. See the [selecting fields](/global-api/selecting-fields) page
        for more information.
      explode: false
      schema:
        $ref: '#/components/schemas/Inventory_API_v1_merchant-fields-enum'
    Inventory_API_v1_fields-rack:
      name: fields:rack
      in: query
      required: false
      description: >-
        Specify additional fields of the `Rack` object to be included in the
        response. See the [selecting fields](/global-api/selecting-fields) page
        for more information.
      explode: false
      schema:
        $ref: '#/components/schemas/Inventory_API_v1_rack-fields-enum'
    Inventory_API_v1_fields-rack-rack_type:
      name: fields:rack.rack_type
      in: query
      required: false
      description: >-
        Specify additional fields of the `RackType` object (via Rack) to be
        included in the response. See the [selecting
        fields](/global-api/selecting-fields) page for more information.
      explode: false
      schema:
        $ref: '#/components/schemas/Inventory_API_v1_rack_type-fields-enum'
    Inventory_API_v1_fields-rack-warehouse:
      name: fields:rack.warehouse
      in: query
      required: false
      description: >-
        Specify additional fields of the `Warehouse` object (via Rack) to be
        included in the response. See the [selecting
        fields](/global-api/selecting-fields) page for more information.
      explode: false
      schema:
        $ref: '#/components/schemas/Inventory_API_v1_warehouse-fields-enum'
    Inventory_API_v1_fields-location_type:
      name: fields:location_type
      in: query
      required: false
      description: >-
        Specify additional fields of the `LocationType` object to be included in
        the response. See the [selecting fields](/global-api/selecting-fields)
        page for more information.
      explode: false
      schema:
        $ref: '#/components/schemas/Inventory_API_v1_location_type-fields-enum'
    Inventory_API_v1_location-filter:
      name: filter
      in: query
      description: >-
        Using the [filtering syntax](/global-api/filtering-syntax), you may
        filter the results using the following fields:
          - `id`
          - `label`
          - `created_at`
          - `updated_at`
          - `qty_putaway`
          - `qty_unreserved`
          - `qty_reserved`
      required: false
      style: form
      explode: true
      schema:
        type: array
        items:
          type: string
      allowReserved: true
      examples:
        Quantity Reserved:
          summary: Get locations where quantity_reserved value is 10.
          value:
            - qty_unreserved:10
    Inventory_API_v1_count:
      name: count
      in: query
      description: >-
        If specified as `1`, the `meta.count` property of the response will be
        present and populated with the total count of items

        matching the query before any paging is applied. This is not included by
        default to improve performance in some edge

        cases and is not required to perform paging using the `next` property of
        the response.

        See [paging parameters](/global-api/paging-parameters) for more
        information.
      style: form
      schema:
        type: integer
        minimum: 0
        maximum: 1
    Inventory_API_v1_cursor_end:
      name: cursor_end
      in: query
      description: >-
        A cursor for use in pagination which defines the last `id` of the next
        page of results, non-inclusive.

        See [paging parameters](/global-api/paging-parameters) for more
        information on paging.
      schema:
        type: integer
      style: form
    Inventory_API_v1_cursor_start:
      name: cursor_start
      in: query
      description: >-
        A cursor for use in pagination which defines the starting `id` of the
        next page of results.

        See [paging parameters](/global-api/paging-parameters) for more
        information on paging.
      schema:
        type: integer
      style: form
    Inventory_API_v1_limit:
      name: limit
      in: query
      description: A limit on the number of objects to be returned.
      style: form
      schema:
        type: integer
        example: 100
        default: 100
        minimum: 1
        maximum: 1000
  schemas:
    Inventory_API_v1_Location:
      title: Location
      type: object
      description: >-
        A Location describes a user-specified inventory address within a
        warehouse.
      properties:
        type:
          type: string
          enum:
            - Location
          readOnly: true
          description: >-
            This is a read-only property that describes the type of object in
            the response body.
        id:
          type: integer
          example: 42
          readOnly: true
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
        label:
          type: string
          nullable: true
          example: A4-55-C3
          description: >-
            The human-readable name of a location and also the value encoded in
            location's barcode label.

            This value must be unique within each warehouse.
        priority:
          type: integer
          example: 10
          description: >-
            The inventory reservation order relative to other locations
            containing the same product.
        qty_putaway:
          type: number
          format: double
          example: 10
          readOnly: true
          nullable: true
          description: >-
            The quantity of a product associated with a Delivery that have not
            yet been committed to the inventory.
        qty_unreserved:
          type: number
          format: double
          example: 20
          readOnly: true
          nullable: true
          description: >-
            The quantity of a product not yet assigned to a specific Shipment.
            This does not imply that the inventory is Available.
        qty_reserved:
          type: number
          format: double
          example: 4
          readOnly: true
          nullable: true
          description: >-
            The quantity assigned to a Shipment or Work Order and ready to be
            picked.
        qty_on_hand:
          type: number
          format: double
          example: 34
          readOnly: true
          nullable: true
          description: >-
            The "On Hand" amount is the same as Put-Away + Unreserved + Reserved
            quantities.
        qty_locked:
          type: number
          format: double
          example: 4
          readOnly: true
          nullable: true
          description: >-
            The quantity that is reserved to a Shipment or Work Order as chosen
            specifically by a user and therefore should not be re-reserved to a
            new location on the fly in the event that an adjustment needs to
            re-optimize pick locations. This amount is already included in
            `qty_reserved` so is not added again to `qty_on_hand`.\
              `Optional Field`
        is_temp:
          type: boolean
          example: false
          readOnly: true
          nullable: true
          description: >-
            Temporary locations are used to track inventory that is being
            relocated and cannot be created or modified.\
              `Optional Field`
        is_pickable:
          type: boolean
          example: true
          nullable: true
          readOnly: true
          description: >-
            Whether or not the location is considered to be easy to pick from
            for the purpose of generating pickable batches.\
              `Optional Field`
        is_type_auto:
          type: boolean
          example: true
          nullable: true
          description: >-
            If Location Type is "Automatic" then it will cause the type to be
            maintained automatically according to the Auto-Assign Patterns of
            the location types.\
              `Optional Field`
        created_at:
          type: string
          format: datetime
          example: '2021-11-17T14:32:44Z'
          readOnly: true
          nullable: true
          description: |-
            The date and time when the object was created.\
              `Optional Field`
        updated_at:
          type: string
          format: datetime
          example: '2021-11-17T14:32:44Z'
          readOnly: true
          description: |-
            The date and time when the object was last updated.\
              `Optional Field`
        last_cyclecount_at:
          type: string
          format: datetime
          example: '2021-11-17T14:32:44Z'
          readOnly: true
          nullable: true
          description: |-
            The date and time when last cycle count was performed.\
              `Optional Field`
        lot:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_LotRef'
            - description: A reference to the `Lot` object assigned to this location.
        product:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_StockableProductRef'
            - description: A reference to the stockable product assigned to this location.
        rack:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_RackRef'
            - description: >-
                A reference to the `Rack` to which this location is assigned.
                This may be managed automatically or assigned manually.
        location_type:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_LocationTypeRef'
            - description: >-
                A reference to the `LocationType` object assigned to this
                location. This may be managed automatically or assigned
                manually.
    Inventory_API_v1_locations:
      type: object
      description: >-
        Lists of referenced objects included by specifying optional fields.

        See the [selecting fields](/global-api/selecting-fields) page for more
        information.
      properties:
        LocationType:
          type: array
          items:
            $ref: '#/components/schemas/Inventory_API_v1_LocationType'
        Lot:
          type: array
          items:
            $ref: '#/components/schemas/Inventory_API_v1_Lot'
        LotType:
          type: array
          items:
            $ref: '#/components/schemas/Inventory_API_v1_LotType'
        Merchant:
          type: array
          items:
            $ref: '#/components/schemas/Inventory_API_v1_Merchant'
        PackagingContainer:
          type: array
          items:
            $ref: '#/components/schemas/Inventory_API_v1_PackagingContainer'
        PackagingDataCollection:
          type: array
          items:
            $ref: '#/components/schemas/Inventory_API_v1_PackagingDataCollection'
        PackagingInfill:
          type: array
          items:
            $ref: '#/components/schemas/Inventory_API_v1_PackagingInfill'
        PackagingInstruction:
          type: array
          items:
            $ref: '#/components/schemas/Inventory_API_v1_PackagingInstruction'
        PackagingSupplies:
          type: array
          items:
            $ref: '#/components/schemas/Inventory_API_v1_PackagingSupplies'
        Product:
          type: array
          items:
            $ref: '#/components/schemas/Inventory_API_v1_CompositeStockableProduct'
        Rack:
          type: array
          items:
            $ref: '#/components/schemas/Inventory_API_v1_Rack'
        RackType:
          type: array
          items:
            $ref: '#/components/schemas/Inventory_API_v1_RackType'
        Warehouse:
          type: array
          items:
            $ref: '#/components/schemas/Inventory_API_v1_Warehouse'
    Inventory_API_v1_has_more:
      type: boolean
      description: |-
        True if the collection has more items on the next page.
        Use the "next" link to retrieve the next page of results.
    Inventory_API_v1_next:
      type: string
      nullable: true
      description: The resource path for the next page of results if any are expected.
    Inventory_API_v1_previous:
      type: string
      nullable: true
      description: The resource path for the previous page of results if any are expected.
    Inventory_API_v1_meta:
      type: object
      properties:
        processing_time:
          type: number
          description: Total time in which request is processed and response is sent back.
          example: 0.2525252525
        cursor_start:
          type: integer
          description: >-
            A cursor for use in pagination which defines the starting `id` of
            the next page of results.

            See [paging parameters](/global-api/paging-parameters) for more
            information on paging.
          nullable: true
        cursor_end:
          type: integer
          description: >-
            A cursor for use in pagination which defines the last `id` of the
            next page of results, non-inclusive.

            See [paging parameters](/global-api/paging-parameters) for more
            information on paging.
          nullable: true
        count:
          type: integer
          description: >-
            The total number of items matching the query before applying paging
            parameters.

            This field is only present if the query parameter `count=1` is
            present in the request.
      description: Additional metadata pertaining to the response.
    Inventory_API_v1_location-fields-enum:
      title: Location
      description: >-
        Specify additional fields of the `Location` object to be included in the
        response.
      type: array
      items:
        type: string
        enum:
          - basic
          - all
          - label
          - priority
          - qty_on_hand
          - qty_putaway
          - qty_unreserved
          - qty_reserved
          - qty_locked
          - is_temp
          - is_pickable
          - is_type_auto
          - created_at
          - updated_at
          - last_cyclecount_at
          - lot
          - product
          - rack
          - location_type
    Inventory_API_v1_lot-fields-enum:
      title: Lot
      description: >-
        Specify additional fields of the `Lot` object to be included in the
        response.
      type: array
      items:
        type: string
        enum:
          - basic
          - all
          - id
          - lot_number
          - origination_date
          - expiration_date
          - is_expired
          - is_active
          - lot_number_input
          - expiration_input
          - sort_value
          - days_until_expiration
          - sort_direction
          - group_value
          - created_at
          - updated_at
          - created_by
          - lot_type
          - product
    Inventory_API_v1_lot_type-fields-enum:
      title: LotType
      description: >-
        Specify additional fields of the `LotType` object to be included in the
        response.
      type: array
      items:
        type: string
        enum:
          - basic
          - all
          - allow_mixing_locations
          - allow_mixing_fulfillment
          - lot_number_example
          - lot_number_replacement
          - expiration_date_pattern
          - expiration_date_delta
          - created_at
          - updated_at
    Inventory_API_v1_product-packaging-fields-enum:
      title: Product Or Packaging
      description: >-
        Specify additional fields of the `Product` or `Packaging*` object to be
        included in the response.
      type: array
      items:
        type: string
        enum:
          - basic
          - all
          - created_at
          - updated_at
          - container_options
          - supplies_options
          - data_collection_options
          - instruction_options
          - infill_options
          - vendor_sku
          - external_id
          - barcodes
          - goods_type
          - is_available
          - is_visible
          - weight
          - dimensions
          - volume
          - inventory
          - export
          - regulated_goods
          - packaging
          - custom_fields
    Inventory_API_v1_merchant-fields-enum:
      title: Merchant
      type: array
      items:
        type: string
        enum:
          - basic
          - all
          - code
          - name
          - status
          - created_at
          - updated_at
          - brands
          - default_brand
          - custom_fields
    Inventory_API_v1_rack-fields-enum:
      title: Rack
      description: >-
        Specify additional fields of the `Rack` object to be included in the
        response.
      type: array
      items:
        type: string
        enum:
          - all
          - id
          - name
          - rack_type
          - location_pattern
          - picking_order
          - warehouse
    Inventory_API_v1_rack_type-fields-enum:
      title: RackType
      description: >-
        Specify additional fields of the `RackType` object to be included in the
        response.
      type: array
      items:
        type: string
        enum:
          - basic
          - all
          - id
          - name
          - notes
    Inventory_API_v1_warehouse-fields-enum:
      title: Warehouse
      description: >-
        Specify additional fields of the `Warehouse` object to be included in
        the response.
      type: array
      items:
        type: string
        enum:
          - basic
          - all
          - id
          - name
          - is_active
          - abbreviation
    Inventory_API_v1_location_type-fields-enum:
      title: LocationType
      description: >-
        Specify additional fields of the `LocationType` object to be included in
        the response.
      type: array
      items:
        type: string
        enum:
          - basic
          - all
          - name
          - is_pickable
          - slot_dimensions
          - created_at
          - updated_at
    Inventory_API_v1_LotRef:
      title: LotRef
      type: object
      description: >-
        A reference to a `Lot` object. The Lot records the time some inventory
        was originated (first received or

        otherwise created) and optionally a lot number and expiration date and
        may affect the order in which

        inventory is "burned" depending on the `LotType`.
      properties:
        type:
          type: string
          enum:
            - Lot
          description: This property describes the type of object in the response body.
        id:
          type: integer
          example: 54
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
      required:
        - type
        - id
      nullable: true
      additionalProperties: false
    Inventory_API_v1_StockableProductRef:
      title: StockableProductRef
      type: object
      description: A reference to a `Product` or stockable packaging type object by `id`.
      properties:
        type:
          type: string
          description: >-
            This is a read-only property that describes the type of object in
            the response body.
          enum:
            - Product
            - PackagingContainer
            - PackagingInfill
            - PackagingSupplies
        id:
          type: integer
          description: >-
            The internal, read-only, `id` property used as a path parameter in a
            resource lookup.
          format: int32
      required:
        - type
        - id
      nullable: true
      additionalProperties: false
    Inventory_API_v1_RackRef:
      title: RackRef
      type: object
      description: >-
        A `Rack` is a grouping of locations in a warehouse implying a very close
        proximity.
      properties:
        type:
          type: string
          enum:
            - Rack
          description: This property describes the type of object in the response body.
        id:
          type: integer
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
      required:
        - type
        - id
      nullable: true
      additionalProperties: false
    Inventory_API_v1_LocationTypeRef:
      title: LocationTypeRef
      type: object
      description: A reference to a `LocationType` object.
      properties:
        type:
          type: string
          enum:
            - LocationType
          description: This property describes the type of object in the response body.
        id:
          type: integer
          example: 54
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
      required:
        - type
        - id
      nullable: true
      additionalProperties: false
    Inventory_API_v1_LocationType:
      title: LocationType
      type: object
      description: >-
        The `LocationType` object allows locations with common attributes or
        purposes to be easily distinguishable.

        The location type also determines if a location is pickable or not which
        may affect whether or not the location

        can be reserved for shipments when creating a batch.
      properties:
        type:
          type: string
          enum:
            - LocationType
          readOnly: true
          description: >-
            This is a read-only property that describes the type of object in
            the response body.
        id:
          type: integer
          example: 54
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
        name:
          type: string
          description: The descriptive name of the location type.
          example: Pickable Pallets
        is_pickable:
          type: boolean
          description: >-
            Whether or not the location is considered to be easy to pick from
            for the purpose of generating pickable batches.
          default: false
        slot_dimensions:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_DimensionsWHD'
            - description: >-
                The interior dimensions of slots assigned to this location
                type.\
                  `Optional Field`
    Inventory_API_v1_Lot:
      title: Lot
      type: object
      description: >-
        The Lot records the time some inventory was originated (first received
        or

        otherwise created) and optionally a lot number and expiration date and
        may affect the order in which

        inventory is "burned" depending on the `LotType`.
      properties:
        type:
          type: string
          enum:
            - Lot
          readOnly: true
          description: >-
            This is a read-only property that describes the type of object in
            the response body.
        id:
          type: integer
          example: 54
          readOnly: true
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
      nullable: true
    Inventory_API_v1_LotType:
      title: LotType
      type: object
      description: LotType
      properties:
        type:
          type: string
          enum:
            - LotType
          readOnly: true
          description: >-
            This is a read-only property that describes the type of object in
            the response body.
        id:
          type: integer
          format: int64
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
          readOnly: true
          example: 4
        name:
          type: string
          description: Any string which uniquely identifies a LotType.
          minLength: 1
          maxLength: 255
          example: MixFulfillment-Extract-Choose-FEFO
        allow_mixing_locations:
          type: boolean
          description: >-
            This flag must be `true` for mixing with other Lots/Expirations in
            the same location..
          example: true
        allow_mixing_fulfillment:
          type: boolean
          description: >-
            This flag must be `true` for mixing with other Lots/Expirations when
            fulfilling an order..
          example: true
        lot_number_input:
          description: The input method used when processing a lot number..
          type: string
          enum:
            - none
            - choose_date
            - extract_date
            - text
          example: text
        lot_number_example:
          type: string
          description: >-
            Enter a typical example of a lot number which can be used to
            validate the Lot Number Pattern. It will also be displayed as an
            example when users are prompted for input.
          example: AB190405G
        lot_number_pattern:
          type: string
          description: >-
            Enter a RegEx for capturing the Lot Number Input. Regex must contain
            one or more capturing group.
          example: ^([A-Z]{2}-[0-9]+)$
        lot_number_replacement:
          type: string
          description: >-
            Enter a RegEx to either save the Lot Number Input as is or transform
            the entry into something more readable. Must contain one or more
            non-empty capturing group from the Lot Number Pattern.
          example: $2$1
        expiration_date:
          type: string
          description: The input method used when processing the expiration date.
          enum:
            - none
            - choose_date
            - extract_date
            - lot_number_date
          example: lot_number_date
        burn_order:
          type: string
          description: Specifies what stock should be used first when fulfilling orders.
          enum:
            - none
            - fifo
            - lifo
            - fefo
            - lefo
            - fifo_lot_number
            - lifo_lot_number
          example: fefo
        created_at:
          $ref: '#/components/schemas/Inventory_API_v1_created_at'
        updated_at:
          $ref: '#/components/schemas/Inventory_API_v1_updated_at'
    Inventory_API_v1_Merchant:
      title: Merchant
      type: object
      description: >-
        A `Merchant` represents an entity that owns a distinct pool of inventory
        and line of business.
      properties:
        type:
          type: string
          enum:
            - Merchant
          readOnly: true
        id:
          type: integer
          format: int32
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
          readOnly: true
          example: 4
        code:
          type: string
          description: >-
            Merchant code may only contain letters (a-z), numbers (0-9) or
            underscore(_), the first character must be a letter.
          minLength: 1
          maxLength: 32
          example: acme_inc
        name:
          type: string
          description: Any string which uniquely identifies a Merchant.
          minLength: 1
          maxLength: 64
          example: ACME Inc.
        status:
          type: string
          enum:
            - active
            - inactive
            - suspended
            - archived
          default: active
          description: >-
            Lifecycle status of the Merchant:

            - `active`: Merchant is operational and available for use

            - `suspended`: Temporarily on hold, can be easily reactivated

            - `inactive`: Long-term offline status, reactivation is possible but
            may require additional steps

            - `archived`: Soft delete status, manual recovery required
          example: active
          nullable: true
          readOnly: true
        created_at:
          $ref: '#/components/schemas/Inventory_API_v1_created_at-optional'
        updated_at:
          $ref: '#/components/schemas/Inventory_API_v1_updated_at'
        brands:
          type: array
          items:
            allOf:
              - $ref: '#/components/schemas/Inventory_API_v1_BrandRef'
          description: >-
            A merchant must have one or more brands which may share the same
            pool of inventory. Brands can be used for

            customizing presentation and behaviors and often correspond to
            distinct lines of business or market presences.\
              `Optional Field`
          readOnly: true
        default_brand:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_BrandRef'
          description: >-
            This is the primary brand used when defining only the merchant for
            operations such as creating a new product.\
              `Optional Field`
        custom_fields:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_sales_custom_fields'
          nullable: true
          description: >-
            Custom fields associated with the merchant in script format. Each
            field contains

            a code and value, with additional properties depending on the field
            type.\
              `Optional Field`
    Inventory_API_v1_PackagingContainer:
      title: PackagingContainer
      description: >-
        A reference to the `PackagingContainer` object linked with Warehouse
        Inventory Location.
      allOf:
        - type: object
          properties:
            type:
              type: string
              enum:
                - PackagingContainer
              description: This property describes the type of object in the response body.
            id:
              type: integer
              description: >-
                The internal, read-only, `id` property used as a path parameter
                in a resource lookup.
              readOnly: true
            container_options:
              type: object
              properties:
                barcodes:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_barcodes'
                    - description: >-
                        A comma separated list of unique packaging feature
                        barcodes.\
                          `Optional Field`
                weight:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Weight'
                    - description: >-
                        The weight of the container when packed with the
                        shipment items.
                dimensions:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Dimensions'
                    - description: >-
                        The dimensions of the container in imperial or metric
                        units.
                volume:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Volume'
                    - description: >-
                        The total volume of the container in imperial or metric
                        units.
                      readOnly: true
                manage_stock:
                  type: boolean
                  description: >-
                    This flag indicates whether or not to adjust the inventory
                    quantity of the packaging feature with each use. If `true`
                    then the inventory levels will decrease with each use. If
                    `no` then the inventory will not adjust with each use.
                  enum:
                    - true
                    - false
                associated_products:
                  type: array
                  description: >-
                    A list of products with this packaging feature selected in
                    its "Other Special Features" option in the product's
                    "Packaging" tab.
                  items:
                    $ref: '#/components/schemas/Inventory_API_v1_ProductRef'
                allow_for_brands:
                  type: array
                  description: >-
                    If specified, this packaging feature will only be applicable
                    to the selected merchants/brands.
                  items:
                    anyOf:
                      - $ref: '#/components/schemas/Inventory_API_v1_MerchantRef'
                      - $ref: '#/components/schemas/Inventory_API_v1_BrandRef'
                disallow_for_brands:
                  type: array
                  description: >-
                    If specified, this packaging feature will not be applicable
                    to the selected merchants/brands.
                  items:
                    anyOf:
                      - $ref: '#/components/schemas/Inventory_API_v1_MerchantRef'
                      - $ref: '#/components/schemas/Inventory_API_v1_BrandRef'
                billing_amount:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Monetary'
                    - description: >-
                        The amount that will be billable for consumption of one
                        unit of this packaging feature.\
                          `Optional Field`
                allow_for_warehouses:
                  type: array
                  description: >-
                    If specified, this packaging feature will only be applicable
                    to the selected warehouses.
                  items:
                    $ref: '#/components/schemas/Inventory_API_v1_WarehouseRef'
                allow_for_shipping_methods:
                  type: array
                  description: >-
                    If specified, this packaging feature will only be applicable
                    to the selected carriers/shipping methods.
                  items:
                    type: string
                satisfies_overbox:
                  type: boolean
                  description: >-
                    Will be a valid container for products which have `Requires
                    Overbox: Yes`.
                  enum:
                    - true
                    - false
                use_for_bin_packing:
                  type: string
                  description: >-
                    Containers with "Use for Bin Packing: No" will not be used
                    by packing solution providers.
                  enum:
                    - 'yes'
                    - 'no'
                    - fallback
                weight_capacity:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Weight'
                    - description: >-
                        Maximum allowed weight of the container, including tare
                        weight.

                        `Optional Field`
                container_style:
                  type: string
                  description: >-
                    Specify the container type. Currently, only "Rigid Box" is
                    supported.
                  enum:
                    - rigid_box
                packaging_handling_surcharge:
                  type: boolean
                  description: >-
                    The Packaging Surcharge is applicable for this packaging
                    feature (e.g. cylindrical, non-fiberboard material,
                    protrusions, non-conveyable, etc.)
                  enum:
                    - true
                    - false
        - $ref: '#/components/schemas/Inventory_API_v1_AbstractProduct'
    Inventory_API_v1_PackagingDataCollection:
      title: PackagingDataCollection
      description: >-
        A reference to the `PackagingDataCollection` object linked with
        Warehouse Inventory Location.
      allOf:
        - $ref: '#/components/schemas/Inventory_API_v1_AbstractProduct'
        - type: object
          properties:
            type:
              type: string
              enum:
                - PackagingDataCollection
              description: This property describes the type of object in the response body.
            id:
              type: integer
              description: >-
                The internal, read-only, `id` property used as a path parameter
                in a resource lookup.
              readOnly: true
            data_collection_options:
              type: object
              properties:
                associated_products:
                  type: array
                  description: >-
                    A list of products with this packaging feature selected in
                    its "Other Special Features" option in the product's
                    "Packaging" tab.
                  items:
                    $ref: '#/components/schemas/Inventory_API_v1_ProductRef'
                allow_for_brands:
                  type: array
                  description: >-
                    If specified, this packaging feature will only be applicable
                    to the selected merchants/brands.
                  items:
                    anyOf:
                      - $ref: '#/components/schemas/Inventory_API_v1_MerchantRef'
                      - $ref: '#/components/schemas/Inventory_API_v1_BrandRef'
                disallow_for_brands:
                  type: array
                  description: >-
                    If specified, this packaging feature will not be applicable
                    to the selected merchants/brands.
                  items:
                    anyOf:
                      - $ref: '#/components/schemas/Inventory_API_v1_MerchantRef'
                      - $ref: '#/components/schemas/Inventory_API_v1_BrandRef'
                billing_amount:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Monetary'
                    - description: >-
                        The amount that will be billable for consumption of one
                        unit of this packaging feature.\
                          `Optional Field`
                allow_for_shipping_methods:
                  type: array
                  description: >-
                    If specified, this packaging feature will only be applicable
                    to the selected carriers/shipping methods.
                  items:
                    type: string
                apply_to_goods_type:
                  type: string
                  enum:
                    - any
                    - NORMAL
                    - ORM_D
                  description: >-
                    This packaging feature will be applied to all shipments
                    containing an item with this Goods Type. \

                    - `NORMAL` Not Regulated

                    - `ORM_D`  ORM-D

                    `Optional Field`
                never_apply_to_goods_type:
                  type: string
                  enum:
                    - NORMAL
                    - LIMITED_QUANTITIES_COMMODITIES
                    - HAZMAT
                  description: >-
                    This packaging feature will be applied to all shipments
                    which do not contain an item with this Goods Type. \

                    - `NORMAL` Not Regulated

                    - `LIMITED_QUANTITIES_COMMODITIES`  Limited Quantities:
                    Consumer Commodity

                    - `HAZMAT` Regulated

                    `Optional Field`
                apply_only_above_weight:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Weight'
                    - description: >-
                        If specified, this packaging product is not a
                        requirement for packages under the given weight when
                        "Always/Never Apply to Goods Type" is specified.

                        `Optional Field`
                one_per:
                  type: string
                  description: >-
                    The expected number of scans per shipment. The product "Unit
                    Quantity" is used as a multiplier for "One Scan Per: Each".
                  enum:
                    - order
                    - package
                    - item
                    - each
                require_scan_timing:
                  type: string
                  description: >-
                    Choose how the scan timer should begin recording time data
                    on this product or packaging feature.
                  enum:
                    - after_product_scan|on_full
                    - on_start
                disable_confirm_button:
                  type: boolean
                  description: >-
                    If "No", the user will be able to tap "Confirm" rather than
                    scanning a barcode.
                  enum:
                    - true
                    - false
                require_packaging_type:
                  type: string
                  description: >-
                    If specified, this packaging feature will only be applicable
                    when the container meets the chosen criteria based on the
                    container's "Satisfies Overbox" attribute when "Always/Never
                    Apply to Goods Type" is specified.
                  enum:
                    - overbox
                    - non_overbox
                apply_unless_container_meets_hazmat:
                  type: boolean
                  description: >-
                    If "Yes", this packaging product will be applicable unless a
                    package contains a DG item with "Container Meets Hazmat
                    Specs: Yes" when "Always/Never Apply to Goods Type" is
                    specified.
                  enum:
                    - true
                    - false
                apply_to_multi_sku_package:
                  type: boolean
                  description: >-
                    If "Yes", this packaging product will only be applied to
                    packages containing more than one SKU when "Always/Never
                    Apply to Goods Type" is specified.
                  enum:
                    - true
                    - false
                collect_data_pattern:
                  type: string
                  description: >-
                    Specify a Javascript-compatible regular expression which
                    describes the format of the data to be collected. Examples:
                    ".+" for anything, or "^[0-9]{15}$" for a 15-digit number.
                    See http://regexpal.com/
                apply_to_region:
                  type: string
                  description: >-
                    Unless specified, this packaging feature will apply to all
                    regions when "Always/Never Apply to Goods Type" is
                    specified.
                is_collected_data_unique:
                  type: boolean
                  description: >-
                    Prevent the same data collection value from being collected
                    more than once on the same shipment.
                  enum:
                    - true
                    - false
    Inventory_API_v1_PackagingInfill:
      title: PackagingInfill
      description: >-
        A reference to the `PackagingInfill` object linked with Warehouse
        Inventory Location.
      allOf:
        - type: object
          properties:
            type:
              type: string
              enum:
                - PackagingInfill
              description: This property describes the type of object in the response body.
            id:
              type: integer
              description: >-
                The internal, read-only, `id` property used as a path parameter
                in a resource lookup.
              readOnly: true
            infill_options:
              type: object
              properties:
                barcodes:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_barcodes'
                    - description: >-
                        A comma separated list of unique packaging feature
                        barcodes.\
                          `Optional Field`
                weight:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Weight'
                    - description: |-
                        The weight of the infill.
                        `Optional Field`
                manage_stock:
                  type: boolean
                  description: >-
                    This flag indicates whether or not to adjust the inventory
                    quantity of the packaging feature with each use. If `true`
                    then the inventory levels will decrease with each use. If
                    `no` then the inventory will not adjust with each use.
                  enum:
                    - true
                    - false
                associated_products:
                  type: array
                  description: >-
                    A list of products with this packaging feature selected in
                    its "Other Special Features" option in the product's
                    "Packaging" tab.
                  items:
                    $ref: '#/components/schemas/Inventory_API_v1_ProductRef'
                allow_for_brands:
                  type: array
                  description: >-
                    If specified, this packaging feature will only be applicable
                    to the selected merchants/brands.
                  items:
                    anyOf:
                      - $ref: '#/components/schemas/Inventory_API_v1_MerchantRef'
                      - $ref: '#/components/schemas/Inventory_API_v1_BrandRef'
                disallow_for_brands:
                  type: array
                  description: >-
                    If specified, this packaging feature will not be applicable
                    to the selected merchants/brands.
                  items:
                    anyOf:
                      - $ref: '#/components/schemas/Inventory_API_v1_MerchantRef'
                      - $ref: '#/components/schemas/Inventory_API_v1_BrandRef'
                billing_amount:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Monetary'
                    - description: >-
                        The amount that will be billable for consumption of one
                        unit of this packaging feature.\
                          `Optional Field`
                disable_confirm_button:
                  type: boolean
                  description: >-
                    If "No", the user will be able to tap "Confirm" rather than
                    scanning a barcode.
                  enum:
                    - true
                    - false
                apply_unless_container_meets_hazmat:
                  type: boolean
                  description: >-
                    If "Yes", this packaging product will be applicable unless a
                    package contains a DG item with "Container Meets Hazmat
                    Specs: Yes" when "Always/Never Apply to Goods Type" is
                    specified.
                  enum:
                    - true
                    - false
                is_confirmation_required:
                  type: boolean
                  description: >-
                    If "Yes", this packer will be prompted and required to
                    confirm the use of infill.
                  enum:
                    - true
                    - false
                infill_horizontal:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Length'
                    - description: >-
                        The amount of space to reserve on each horizontal side
                        of the package for infill. \

                        `Optional Field`
                infill_vertical:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Length'
                    - description: >-
                        The amount of space to reserve on each vertical side of
                        the package for infill.

                        `Optional Field`
                infill_priority:
                  type: integer
                  description: >-
                    If multiple infill types are prescribed for a mix of items,
                    the infill with the lowest Infill Priority number will
                    prevail.
        - $ref: '#/components/schemas/Inventory_API_v1_AbstractProduct'
    Inventory_API_v1_PackagingInstruction:
      title: PackagingInstruction
      description: >-
        A reference to the `PackagingInstruction` object linked with Warehouse
        Inventory Location.
      allOf:
        - type: object
          properties:
            type:
              type: string
              enum:
                - PackagingInstruction
              description: This property describes the type of object in the response body.
            id:
              type: integer
              description: >-
                The internal, read-only, `id` property used as a path parameter
                in a resource lookup.
              readOnly: true
            instruction_options:
              type: object
              properties:
                barcodes:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_barcodes'
                    - description: >-
                        A comma separated list of unique packaging feature
                        barcodes.\
                          `Optional Field`
                associated_products:
                  type: array
                  description: >-
                    A list of products with this packaging feature selected in
                    its "Other Special Features" option in the product's
                    "Packaging" tab.
                  items:
                    $ref: '#/components/schemas/Inventory_API_v1_ProductRef'
                allow_for_brands:
                  type: array
                  description: >-
                    If specified, this packaging feature will only be applicable
                    to the selected merchants/brands.
                  items:
                    anyOf:
                      - $ref: '#/components/schemas/Inventory_API_v1_MerchantRef'
                      - $ref: '#/components/schemas/Inventory_API_v1_BrandRef'
                disallow_for_brands:
                  type: array
                  description: >-
                    If specified, this packaging feature will not be applicable
                    to the selected merchants/brands.
                  items:
                    anyOf:
                      - $ref: '#/components/schemas/Inventory_API_v1_MerchantRef'
                      - $ref: '#/components/schemas/Inventory_API_v1_BrandRef'
                billing_amount:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Monetary'
                    - description: >-
                        The amount that will be billable for consumption of one
                        unit of this packaging feature.\
                          `Optional Field`
                allow_for_shipping_methods:
                  type: array
                  description: >-
                    If specified, this packaging feature will only be applicable
                    to the selected carriers/shipping methods.
                  items:
                    type: string
                apply_to_goods_type:
                  type: string
                  enum:
                    - any
                    - NORMAL
                    - ORM_D
                  description: >-
                    This packaging feature will be applied to all shipments
                    containing an item with this Goods Type.

                    - `NORMAL` Not Regulated

                    - `ORM_D`  ORM-D

                    `Optional Field`
                never_apply_to_goods_type:
                  type: string
                  enum:
                    - NORMAL
                    - LIMITED_QUANTITIES_COMMODITIES
                    - HAZMAT
                  description: >-
                    This packaging feature will be applied to all shipments
                    which do not contain an item with this Goods Type.

                    - `NORMAL` Not Regulated

                    - `LIMITED_QUANTITIES_COMMODITIES`  Limited Quantities:
                    Consumer Commodity

                    - `HAZMAT` Regulated

                    `Optional Field`
                apply_only_above_weight:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Weight'
                    - description: >-
                        If specified, this packaging product is not a
                        requirement for packages under the given weight when
                        "Always/Never Apply to Goods Type" is specified. \

                        `Optional Field`
                one_per:
                  type: string
                  description: >-
                    The expected number of scans per shipment. The product "Unit
                    Quantity" is used as a multiplier for "One Scan Per: Each".
                  enum:
                    - order
                    - package
                    - item
                    - each
                require_scan_timing:
                  type: string
                  description: >-
                    Choose how the scan timer should begin recording time data
                    on this product or packaging feature.
                  enum:
                    - after_product_scan|on_full
                    - on_start
                disable_confirm_button:
                  type: boolean
                  description: >-
                    If "No", the user will be able to tap "Confirm" rather than
                    scanning a barcode.
                  enum:
                    - true
                    - false
                require_packaging_type:
                  type: string
                  description: >-
                    If specified, this packaging feature will only be applicable
                    when the container meets the chosen criteria based on the
                    container's "Satisfies Overbox" attribute when "Always/Never
                    Apply to Goods Type" is specified.
                  enum:
                    - overbox
                    - non_overbox
                apply_to_region:
                  type: string
                  description: >-
                    Unless specified, this packaging feature will apply to all
                    regions when "Always/Never Apply to Goods Type" is
                    specified.
                apply_unless_container_meets_hazmat:
                  type: boolean
                  description: >-
                    If "Yes", this packaging product will be applicable unless a
                    package contains a DG item with "Container Meets Hazmat
                    Specs: Yes" when "Always/Never Apply to Goods Type" is
                    specified.
                  enum:
                    - true
                    - false
                apply_to_multi_sku_package:
                  type: boolean
                  description: >-
                    If "Yes", this packaging product will only be applied to
                    packages containing more than one SKU when "Always/Never
                    Apply to Goods Type" is specified.
                  enum:
                    - true
                    - false
        - $ref: '#/components/schemas/Inventory_API_v1_AbstractProduct'
    Inventory_API_v1_PackagingSupplies:
      title: PackagingSupplies
      description: >-
        A reference to the `PackagingSupplies` object linked with Warehouse
        Inventory Location.
      allOf:
        - type: object
          properties:
            type:
              type: string
              enum:
                - PackagingSupplies
              description: This property describes the type of object in the response body.
            id:
              type: integer
              description: >-
                The internal, read-only, `id` property used as a path parameter
                in a resource lookup.
              readOnly: true
            supplies_options:
              type: object
              properties:
                barcodes:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_barcodes'
                    - description: >-
                        A comma separated list of unique packaging feature
                        barcodes.\
                          `Optional Field`
                weight:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Weight'
                    - description: |-
                        The weight of the infill.
                        `Optional Field`
                manage_stock:
                  type: boolean
                  description: >-
                    This flag indicates whether or not to adjust the inventory
                    quantity of the packaging feature with each use. If `true`
                    then the inventory levels will decrease with each use. If
                    `no` then the inventory will not adjust with each use.
                  enum:
                    - true
                    - false
                associated_products:
                  type: array
                  description: >-
                    A list of products with this packaging feature selected in
                    its "Other Special Features" option in the product's
                    "Packaging" tab.
                  items:
                    $ref: '#/components/schemas/Inventory_API_v1_ProductRef'
                allow_for_brands:
                  type: array
                  description: >-
                    If specified, this packaging feature will only be applicable
                    to the selected merchants/brands.
                  items:
                    anyOf:
                      - $ref: '#/components/schemas/Inventory_API_v1_MerchantRef'
                      - $ref: '#/components/schemas/Inventory_API_v1_BrandRef'
                disallow_for_brands:
                  type: array
                  description: >-
                    If specified, this packaging feature will not be applicable
                    to the selected merchants/brands.
                  items:
                    anyOf:
                      - $ref: '#/components/schemas/Inventory_API_v1_MerchantRef'
                      - $ref: '#/components/schemas/Inventory_API_v1_BrandRef'
                billing_amount:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Monetary'
                    - description: >-
                        The amount that will be billable for consumption of one
                        unit of this packaging feature.\
                          `Optional Field`
                allow_for_warehouses:
                  type: array
                  description: >-
                    If specified, this packaging feature will only be applicable
                    to the selected warehouses.
                  items:
                    $ref: '#/components/schemas/Inventory_API_v1_WarehouseRef'
                allow_for_shipping_methods:
                  type: array
                  description: >-
                    If specified, this packaging feature will only be applicable
                    to the selected carriers/shipping methods.
                  items:
                    type: string
                packaging_handling_surcharge:
                  type: boolean
                  description: >-
                    The Packaging Surcharge is applicable for this packaging
                    feature (e.g. cylindrical, non-fiberboard material,
                    protrusions, non-conveyable, etc.)
                  enum:
                    - true
                    - false
                apply_to_goods_type:
                  type: string
                  enum:
                    - any
                    - NORMAL
                    - ORM_D
                  description: >-
                    This packaging feature will be applied to all shipments
                    which do not contain an item with this Goods Type.

                    - `NORMAL` Not Regulated

                    - `ORM_D`  ORM-D

                    `Optional Field`
                never_apply_to_goods_type:
                  type: string
                  enum:
                    - NORMAL
                    - LIMITED_QUANTITIES_COMMODITIES
                    - HAZMAT
                  description: >-
                    This packaging feature will be applied to all shipments
                    which do not contain an item with this Goods Type.

                    - `NORMAL` Not Regulated

                    - `LIMITED_QUANTITIES_COMMODITIES`  Limited Quantities:
                    Consumer Commodity

                    - `HAZMAT` Regulated

                    `Optional Field`
                apply_only_above_weight:
                  allOf:
                    - $ref: '#/components/schemas/Inventory_API_v1_Weight'
                    - description: >-
                        If specified, this packaging supply is not a requirement
                        for packages under the given weight when "Always/Never
                        Apply to Goods Type" is specified.

                        `Optional Field`
                one_per:
                  type: string
                  description: >-
                    The expected number of scans per shipment. The product "Unit
                    Quantity" is used as a multiplier for "One Scan Per: Each".
                  enum:
                    - order
                    - package
                    - item
                    - each
                require_scan_timing:
                  type: string
                  description: >-
                    Choose how the scan timer should begin recording time data
                    on this product or packaging feature.
                  enum:
                    - after_product_scan|on_full
                    - on_start
                disable_confirm_button:
                  type: boolean
                  description: >-
                    If "No", the user will be able to tap "Confirm" rather than
                    scanning a barcode.
                  enum:
                    - true
                    - false
                require_packaging_type:
                  type: string
                  description: >-
                    If specified, this packaging feature will only be applicable
                    when the container meets the chosen criteria based on the
                    container's "Satisfies Overbox" attribute when "Always/Never
                    Apply to Goods Type" is specified.
                  enum:
                    - overbox
                    - non_overbox
                apply_to_region:
                  type: string
                  description: >-
                    Unless specified, this packaging feature will apply to all
                    regions when "Always/Never Apply to Goods Type" is
                    specified.
                apply_unless_container_meets_hazmat:
                  type: boolean
                  description: >-
                    If "Yes", this packaging product will be applicable unless a
                    package contains a DG item with "Container Meets Hazmat
                    Specs: Yes" when "Always/Never Apply to Goods Type" is
                    specified.
                  enum:
                    - true
                    - false
                apply_to_multi_sku_package:
                  type: boolean
                  description: >-
                    If "Yes", this packaging product will only be applied to
                    packages containing more than one SKU when "Always/Never
                    Apply to Goods Type" is specified.
                  enum:
                    - true
                    - false
        - $ref: '#/components/schemas/Inventory_API_v1_AbstractProduct'
    Inventory_API_v1_CompositeStockableProduct:
      anyOf:
        - $ref: '#/components/schemas/Inventory_API_v1_Product'
        - $ref: '#/components/schemas/Inventory_API_v1_PackagingContainer'
        - $ref: '#/components/schemas/Inventory_API_v1_PackagingSupplies'
        - $ref: '#/components/schemas/Inventory_API_v1_PackagingInfill'
      discriminator:
        propertyName: type
    Inventory_API_v1_Rack:
      title: Rack
      type: object
      description: >-
        A `Rack` is a grouping of locations in a warehouse implying a very close
        proximity.
      properties:
        type:
          type: string
          enum:
            - Rack
          readOnly: true
          description: This property describes the type of object in the response body.
        id:
          type: integer
          example: 54
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
        rack_type:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_RackTypeRef'
            - description: A reference to the `RackType` that classifies this rack.
      nullable: true
    Inventory_API_v1_RackType:
      title: RackType
      type: object
      description: >-
        A `RackType` classifies racks by their physical characteristics (e.g.
        "Wide Aisle", "Narrow Aisle").
      properties:
        type:
          type: string
          enum:
            - RackType
          readOnly: true
          description: This property describes the type of object in the response body.
        id:
          type: integer
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
          example: 1
        name:
          type: string
          description: The name of the rack type.
          example: Wide Aisle
        notes:
          type: string
          nullable: true
          description: Optional notes about this rack type.
      nullable: true
    Inventory_API_v1_Warehouse:
      title: Warehouse
      type: object
      description: >-
        A `Warehouse` represents a physical location from which you can store
        inventory and perform operations independently of other warehouses.
      properties:
        type:
          type: string
          enum:
            - Warehouse
          readOnly: true
          description: >-
            This is a read-only property that describes the type of object in
            the response body.
        id:
          type: integer
          format: int32
          example: 3
          readOnly: true
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
        name:
          type: string
          example: East Coast 1
          maxLength: 255
          description: The display name for the `Warehouse`.
        abbreviation:
          type: string
          maxLength: 10
          nullable: true
          example: EC1
          description: >-
            A short abbreviation for the `Warehouse`, up to 10 characters.
            Recommended to be fewer than 6 characters.\
              `Optional Field`
        is_active:
          type: boolean
          example: true
          description: >-
            This flag determines if the `Warehouse` is active and viable for
            fulfillment.
      required:
        - type
        - id
      additionalProperties: false
    Inventory_API_v1_DimensionsWHD:
      title: DimensionsWHD
      type: object
      nullable: true
      properties:
        width:
          type: number
          description: The width defined as a floating-point number up to 4 decimal places.
          format: float
          example: 48
        height:
          type: number
          description: >-
            The height defined as a floating-point number up to 4 decimal
            places.
          format: float
          example: 60
        depth:
          type: number
          description: The depth defined as a floating-point number up to 4 decimal places.
          format: float
          example: 42
        unit:
          $ref: '#/components/schemas/Inventory_API_v1_LengthUnit'
    Inventory_API_v1_created_at:
      type: string
      format: date-time
      description: >-
        The date and time the object was created in RFC 3339 section 5.6
        notation.
      example: '2017-07-21T17:32:28Z'
      readOnly: true
    Inventory_API_v1_updated_at:
      type: string
      format: date-time
      description: >-
        The date and time the object was last updated in RFC 3339 section 5.6
        notation.\
          `Optional Field`
      example: '2017-07-21T17:39:43Z'
      nullable: true
      readOnly: true
    Inventory_API_v1_created_at-optional:
      type: string
      format: date-time
      description: >-
        The date and time the object was created in RFC 3339 section 5.6
        notation.\
          `Optional Field`
      example: '2017-07-21T17:32:28Z'
      nullable: true
      readOnly: true
    Inventory_API_v1_BrandRef:
      title: BrandRef
      type: object
      description: Reference a `Brand` by `id`.
      properties:
        type:
          type: string
          enum:
            - Brand
        id:
          type: integer
          format: int32
          description: The numeric `id` of a particular resource being updated.
          example: 4
      required:
        - type
        - id
      additionalProperties: false
    Inventory_API_v1_sales_custom_fields:
      type: object
      description: >-
        Custom field values for the order, keyed by field code.


        The format of each value depends on the field's input type:

        - **select**: `{"id": <integer>, "label": "<string>"}`

        - **multiselect**: `[{"id": <integer>, "label": "<string>"}, ...]`

        - **currency**: Uses the Monetary type `{"amount": <number>, "currency":
        "<string>"}`

        - **boolean**: `{"value": <boolean>}`

        - **text/multiline-text/email/url/date**: `{"value": "<string>"}`

        - **number**: `{"value": <number>}`

        - **admin-user/client-user**: `{"value": <integer>}` (user ID)
      additionalProperties:
        $ref: '#/components/schemas/Inventory_API_v1_custom_field_value'
      example:
        is_gift:
          value: true
        order_details:
          value: test details
        department:
          id: 3
          label: Shipping
        priority_levels:
          - id: 1
            label: Urgent
          - id: 2
            label: High
        cost_of_goods:
          amount: 156.99
          currency: USD
        assigned_user:
          value: 42
    Inventory_API_v1_barcodes:
      anyOf:
        - type: string
          nullable: true
          example: 956623520-4
        - type: array
          items:
            type: string
          nullable: true
          example:
            - 956623520-4
            - O-VS-Oregano-p3
    Inventory_API_v1_Weight:
      title: Weight
      type: object
      nullable: true
      properties:
        value:
          type: number
          description: >-
            The weight quantity defined as a floating point value of up to 4
            decimal places.
          format: float
          example: 20
        unit:
          $ref: '#/components/schemas/Inventory_API_v1_WeightUnit'
    Inventory_API_v1_Dimensions:
      title: Dimensions
      type: object
      nullable: true
      properties:
        length:
          type: number
          description: >-
            This distance value is usually assigned to the longest side of the
            object and is defined as a floating-point number up to 4 decimal
            places.
          format: float
          example: 8
        width:
          type: number
          description: >-
            This value describes the horizontal distance of the subject defined
            as a floating-point number up to 4 decimal places.
          format: float
          example: 6
        height:
          type: number
          description: >-
            This value describes the vertical distance of the subject defined as
            a floating-point number up to 4 decimal places.
          format: float
          example: 4
        unit:
          $ref: '#/components/schemas/Inventory_API_v1_LengthUnit'
    Inventory_API_v1_Volume:
      title: Volume
      type: object
      nullable: true
      properties:
        value:
          type: number
          description: >-
            This value describes the cubic size of the subject as a
            floating-point number up to 4 decimal places.
          format: float
          example: 300
        unit:
          $ref: '#/components/schemas/Inventory_API_v1_VolumeUnit'
    Inventory_API_v1_ProductRef:
      title: ProductRef
      type: object
      description: A reference to a `Product` object by `id`.
      properties:
        type:
          type: string
          enum:
            - Product
          description: This property describes the type of object in the response body.
        id:
          type: integer
          format: int32
          example: 3
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
      required:
        - type
        - id
      additionalProperties: false
    Inventory_API_v1_MerchantRef:
      title: MerchantRef
      type: object
      description: Reference a `Merchant` by `id`.
      properties:
        type:
          type: string
          enum:
            - Merchant
        id:
          type: integer
          format: int32
          example: 4
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
      required:
        - type
        - id
      additionalProperties: false
    Inventory_API_v1_Monetary:
      title: Monetary
      type: object
      nullable: true
      properties:
        amount:
          type: number
          description: This is the monetary value..
          format: float
          example: 99
        currency:
          type: string
          description: An ISO 3166-1 alpha-3 currency code.
          example: USD
    Inventory_API_v1_WarehouseRef:
      title: WarehouseRef
      type: object
      description: A reference to a `Warehouse` by `id`.
      properties:
        type:
          type: string
          enum:
            - Warehouse
          description: This property describes the type of object in the response body.
        id:
          type: integer
          format: int32
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
      required:
        - type
        - id
      nullable: true
      additionalProperties: false
    Inventory_API_v1_AbstractProduct:
      type: object
      properties:
        sku:
          type: string
          description: >-
            The Stock Keeping Unit (SKU) is a unique identifier for the
            `Product`.
          example: SKU-1AD
        name:
          type: string
          description: This is displayed as a short, descriptive title for the `Product`.
          example: Test Product
        is_enabled:
          type: boolean
          description: Disabled products are effectively deleted.
          enum:
            - true
            - false
          default: true
        merchant:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_MerchantRef'
            - description: The `Merchant` to which the product belongs.
        created_at:
          $ref: '#/components/schemas/Inventory_API_v1_created_at-optional'
        updated_at:
          $ref: '#/components/schemas/Inventory_API_v1_updated_at-optional'
    Inventory_API_v1_Length:
      title: Length
      type: object
      nullable: true
      properties:
        value:
          type: number
          description: >-
            This value describes the length of the object as a floating-point
            number up to 4 decimal places.
          format: float
          example: 12
        unit:
          $ref: '#/components/schemas/Inventory_API_v1_LengthUnit'
    Inventory_API_v1_Product:
      title: Product
      description: A Product contains information about a sellable item.
      allOf:
        - type: object
          properties:
            type:
              type: string
              enum:
                - Product
              description: This property describes the type of object in the response body.
            id:
              type: integer
              description: >-
                The internal, read-only, `id` property used as a path parameter
                in a resource lookup.
              readOnly: true
            vendor_sku:
              type: string
              description: >-
                For informational use only. Displayed during delivery processing
                to help match products.\
                  `Optional Field`
              nullable: true
              example: Vendor-SKU-1AD2
            external_id:
              type: string
              nullable: true
              example: 11-993-9048
              description: May be used for external product sync.
            barcodes:
              anyOf:
                - type: array
                  items:
                    type: string
                  nullable: true
                  example:
                    - 956623520-4
                    - O-VS-Oregano-p3
                - type: string
                  nullable: true
                  example: 956623520-4
              description: A comma separated list of unique packaging feature barcodes.
            goods_type:
              type: string
              enum:
                - NORMAL
                - ORM_D
                - LIMITED_QUANTITIES_COMMODITIES
                - HAZMAT
              description: >-
                This defines the regulations, if any, assigned to a `Product`.

                - `NORMAL` Not Regulated

                - `ORM_D`  ORM-D

                - `LIMITED_QUANTITIES_COMMODITIES`  Limited Quantities: Consumer
                Commodity

                - `HAZMAT` Regulated
            is_available:
              type: boolean
              enum:
                - true
                - false
              default: true
              description: This flag must be `true` to allow the `Product` to be ordered.
            is_visible:
              type: boolean
              enum:
                - true
                - false
              default: true
              description: >-
                This flag must be `true` to show the `Product` in the inventory
                feed.
            lot_type:
              allOf:
                - $ref: '#/components/schemas/Inventory_API_v1_LotTypeRef'
                - description: >-
                    This `LotType` determines how a `Product` should be "burned"
                    and whether lots with dissimilar data

                    can be "mixed".\
                      `Optional Field`
            weight:
              allOf:
                - $ref: '#/components/schemas/Inventory_API_v1_Weight'
                - description: >-
                    This object defines the weight of the `Product` in imperial
                    or metric units.\
                      `Optional Field`
            dimensions:
              allOf:
                - $ref: '#/components/schemas/Inventory_API_v1_Dimensions'
                - description: >-
                    This object defines the length, width, and height of the
                    `Product` in imperial or metric units.\
                      `Optional Field`
            volume:
              allOf:
                - $ref: '#/components/schemas/Inventory_API_v1_Volume'
                - description: >-
                    This object defines the cubic size of the `Product` in
                    imperial or metric units.\
                      `Optional Field`
            inventory:
              allOf:
                - $ref: '#/components/schemas/Inventory_API_v1_Inventory'
                - description: >-
                    This object describes how the `Product` Stock is defined,
                    such as real config values, or Virtual Inventory, and how to
                    handle Backorders.\
                      `Optional Field`
            export:
              allOf:
                - $ref: '#/components/schemas/Inventory_API_v1_Export'
                - description: >-
                    This object contains fields for describing and codifying an
                    internationally exportable `Product`.\
                      `Optional Field`
            regulated_goods:
              allOf:
                - $ref: '#/components/schemas/Inventory_API_v1_RegulatedGoods'
                - description: >-
                    This object only applies a `Product` using the "Regulated"
                    Goods Type, and describes the `Regulation` and container
                    specifications for the `Product`.\
                      `Optional Field`
            packaging:
              allOf:
                - $ref: '#/components/schemas/Inventory_API_v1_Packaging'
                - description: >-
                    This object defines how the shipping container/box for the
                    `Product` is to be processed and whether there are any
                    special instructions during packing.\
                      `Optional Field`
            custom_fields:
              allOf:
                - $ref: '#/components/schemas/Inventory_API_v1_custom_fields'
                - description: >-
                    This will set any Product Attributes, pre-defined by the
                    user, for the `Product`.\
                      `Optional Field`
        - $ref: '#/components/schemas/Inventory_API_v1_AbstractProduct'
    Inventory_API_v1_RackTypeRef:
      title: RackTypeRef
      type: object
      description: >-
        A `RackType` classifies racks by their physical characteristics (e.g.
        "Wide Aisle", "Narrow Aisle").
      properties:
        type:
          type: string
          enum:
            - RackType
          description: This property describes the type of object in the response body.
        id:
          type: integer
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
      required:
        - type
        - id
      nullable: true
      additionalProperties: false
    Inventory_API_v1_LengthUnit:
      type: string
      description: The imperical or metric unit of measurement.
      enum:
        - in
        - mm
        - cm
        - m
    Inventory_API_v1_custom_field_value:
      description: Union type for all possible custom field value formats.
      anyOf:
        - $ref: '#/components/schemas/Inventory_API_v1_custom_field_scalar_value'
        - $ref: '#/components/schemas/Inventory_API_v1_Monetary'
        - $ref: '#/components/schemas/Inventory_API_v1_custom_field_select_option'
        - $ref: '#/components/schemas/Inventory_API_v1_custom_field_multiselect_value'
    Inventory_API_v1_WeightUnit:
      type: string
      description: This can be an imperial or metric unit for weight.
      enum:
        - lb
        - oz
        - kg
        - g
    Inventory_API_v1_VolumeUnit:
      type: string
      description: The imperical or metric unit of measurement as a cubic value.
      enum:
        - in^3
        - mm^3
        - cm^3
        - m^3
    Inventory_API_v1_updated_at-optional:
      type: string
      format: date-time
      description: >-
        The date and time the object was last updated in RFC 3339 section 5.6
        notation.
      example: '2017-07-21T17:39:43Z'
      nullable: true
      readOnly: true
    Inventory_API_v1_LotTypeRef:
      title: LotTypeRef
      description: LotType
      type: object
      properties:
        type:
          type: string
          enum:
            - LotType
          description: This property describes the type of object in the response body.
        id:
          type: integer
          format: int64
          description: >-
            The internal `id` property used as a path parameter in a resource
            lookup.
          example: 4
      required:
        - type
        - id
      nullable: true
      additionalProperties: false
    Inventory_API_v1_Inventory:
      title: Inventory
      type: object
      description: Product Inventory information
      properties:
        backorders:
          description: >-
            This determines if `Product` that is no longer in stock may be
            backordered or whether or not to use ShipStream's scoped
            configurations.
          anyOf:
            - type: boolean
              example: true
            - type: string
              enum:
                - use_config
        dynamic_allocation:
          description: >-
            This will allow the `Product` to source from inventory in other
            warehouses in real-time if enabled, and can be set to use
            ShipStream's scoped configurations.
          anyOf:
            - type: boolean
              example: true
            - type: string
              enum:
                - use_config
        virtual_inventory:
          type: string
          description: >-
            This is the method used to predict an esitmate of inventory
            available when kitting from the `Product`.
          enum:
            - none
            - optimistic
            - realistic
            - pessimistic
          example: optimistic
    Inventory_API_v1_Export:
      title: Export
      type: object
      description: Product Export and Custom information
      properties:
        description:
          type: string
          description: >-
            This is used to describe in detail the `Product` for international
            shipping and customs regulations.
          nullable: true
          example: Plastic children's toy with steel weights and ball bearings
        customs_value:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_Monetary'
            - description: >-
                The value of the products the purpose of calculating duties and
                taxes in the destination country.
        country_of_manufacture:
          type: string
          nullable: true
          description: 2 letters Country ISO Code
          example: TW
        hs_base_code:
          type: string
          description: >-
            This is the Harmonized System Code (HS Code); a standardized
            numerical method of classifying traded products. These are 6 digit
            codes in the format \#\#\#.\#\# which are associated with a standard
            HS Code Description.
          nullable: true
          example: '8518.30'
        hs_country_extension:
          $ref: '#/components/schemas/Inventory_API_v1_country_extension'
    Inventory_API_v1_RegulatedGoods:
      title: RegulatedGoods
      type: object
      description: Product Regulation Information
      properties:
        regulation:
          $ref: '#/components/schemas/Inventory_API_v1_RegulationRef'
        technical_name:
          type: string
          nullable: true
          description: Must match against Regulation's Technical Name Pattern if specified.
          example: Hydro Polymer Acetylene Coating
        additional_information:
          type: string
          nullable: true
          description: >-
            Must match against Regulation's Additional Regulatory Information
            Pattern if specified.
          example: Flamable Liquid
        net_weight:
          $ref: '#/components/schemas/Inventory_API_v1_Weight'
        container_type:
          $ref: '#/components/schemas/Inventory_API_v1_container_type'
        container_meets_hazmat_specs:
          type: boolean
          description: >-
            This flag indicates that the `RegulatedGoods` container is
            sufficient for a regulated (HAZMAT) product.
          example: true
        regulation_units:
          type: number
          description: >-
            These units are arbitrary and should be relative to the Regulation's
            Pickup Weight Limit. E.g. it could be in pounds, kilowatt/hours,
            etc.
          format: float
          example: 5
    Inventory_API_v1_Packaging:
      title: Packaging
      type: object
      description: Product Packaging information
      properties:
        require_packaging:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_boolean'
            - description: >-
                If Yes, packaging will require a Box with "Satisfies Overbox:
                Yes".
        require_weight_check:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_boolean'
            - description: >-
                If Yes, the associated product will require the use of a scale
                to verify that the package's weight falls within the expected
                amount. If this is set to No, this step will be skipped by the
                packer.
        require_confirmation_per_item:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_boolean'
            - description: >-
                If Yes, Packaging Products with "One Scan Per: Item" will
                require a scan for each item packed rather than just one for the
                first item in a package.
        unit_quantity:
          type: integer
          example: 1
          nullable: true
          description: >-
            Number of individually packaged items contained therein for purposes
            of special packaging features.
        bulk_quantity:
          type: integer
          nullable: true
          example: 10
          description: >-
            Prefer to split into packages when necessary using multiples of this
            amount.
        max_per_package:
          type: integer
          nullable: true
          example: 15
          description: >-
            The maximum quantity of this product to ever include in the same
            package. 

            Multiply by "Unit Quantity" to achieve common units between other
            products with the same "Ship Separate Tag" value.
        is_ship_separately:
          allOf:
            - $ref: '#/components/schemas/Inventory_API_v1_boolean'
            - description: >-
                This item cannot ship in the same package as other items (unless
                they have the same "Ship Separate Tag").
[...]
